Last Comment Bug 665964 - The backbutton stops working if an nsISHistoryListener vetoes navigation.
: The backbutton stops working if an nsISHistoryListener vetoes navigation.
Status: RESOLVED FIXED
[regression from 622315][qa-]
: regression
Product: Core
Classification: Components
Component: Document Navigation (show other bugs)
: unspecified
: All All
: -- normal (vote)
: mozilla7
Assigned To: Kyle Huey [:khuey] (khuey@mozilla.com)
:
Mentors:
Depends on:
Blocks: 622315
  Show dependency treegraph
 
Reported: 2011-06-21 11:00 PDT by Jeff Muizelaar [:jrmuizel]
Modified: 2011-09-22 15:27 PDT (History)
8 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
+
fixed
fixed


Attachments
Fix at least one bug (810 bytes, patch)
2011-07-08 11:49 PDT, Kyle Huey [:khuey] (khuey@mozilla.com)
bzbarsky: review+
asa: approval‑mozilla‑aurora+
Details | Diff | Review

Description Jeff Muizelaar [:jrmuizel] 2011-06-21 11:00:07 PDT
I've seen this twice now. The back button remains inactive even after navigating to different pages. It only seems to affect a single tab. I have no idea how to reproduce it.
Comment 1 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-06-21 12:34:42 PDT
I wonder if this is related to Bug 622315.
Comment 2 Boris Zbarsky [:bz] (Out June 25-July 6) 2011-06-21 13:13:38 PDT
Could be....
Comment 3 Josh Matthews [:jdm] 2011-06-21 13:23:20 PDT
I can reproduce this by opening a new tab, starting a page load then cancelling it immediately. No matter where I navigate in that tab from then on, the back button is always disabled.
Comment 4 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-06-21 13:24:37 PDT
I can reproduce that as well.  I'll dig in here.
Comment 5 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-06-21 14:31:17 PDT
This does not seem to be a regression from Bug 662315.  Bisecting now.
Comment 6 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-06-21 20:46:47 PDT
I can only seem to reproduce this sporadically :-(
Comment 7 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-07-02 12:39:49 PDT
I still haven't been able to come up with reliable STR, but I managed to hit this and popped into a debugger and the issue is indeed that mRequestedIndex is not reset.  At this point I'm just going to try to audit the relevant codepaths.
Comment 8 Asa Dotzler [:asa] 2011-07-07 14:55:17 PDT
tracking because if this is widespread, it would be concerning.
Comment 9 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-07-07 16:44:27 PDT
Brief summary:

In bug 622315 we gated navigation on checking nsSHistory::mRequestedIndex to see if there was already a pending navigation.  mRequestedIndex does not always get reset properly, so there are times where we think we're navigating and disable back/forwards when we shouldn't.

Without reliable STR this is going to be difficult to fix.  We can back out the regressing changeset if it comes to that.  This affects 7, so we have some time to figure this out.
Comment 10 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-07-08 11:49:18 PDT
Created attachment 544874 [details] [diff] [review]
Fix at least one bug

If the nsISHistoryListener vetoes we don't set mRequestedIndex.  This can't be hit in stock Firefox, afaict, but an addon could trigger this.
Comment 11 Boris Zbarsky [:bz] (Out June 25-July 6) 2011-07-08 12:10:42 PDT
Comment on attachment 544874 [details] [diff] [review]
Fix at least one bug

r=me
Comment 12 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-07-08 14:29:16 PDT
Comment on attachment 544874 [details] [diff] [review]
Fix at least one bug

Drivers, this fixes a particular codepath that addons can trigger in Firefox 7 that will cause forward/backwards to stop working on the tab.
Comment 13 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-07-08 14:32:00 PDT
http://hg.mozilla.org/integration/mozilla-inbound/rev/2ca111e7c2fb
Comment 14 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-07-09 20:23:23 PDT
http://hg.mozilla.org/mozilla-central/rev/2ca111e7c2fb
Comment 15 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-07-12 14:52:37 PDT
http://hg.mozilla.org/releases/mozilla-aurora/rev/ffeea656548b

I'm going to open another bug for the general audit.
Comment 16 Jeff Muizelaar [:jrmuizel] 2011-08-09 22:41:36 PDT
I'm seeing this again on a nightly from 2011-08-09.
Comment 17 Simona B [:simonab] 2011-08-19 08:35:20 PDT
Mozilla/5.0 (Windows NT 5.1; rv:7.0) Gecko/20100101 Firefox/7.0

I tried to verify this fix, but i wasn't able to reproduce this issue with the steps in Comment 3. Can anyone please help me with a test case or with thorough STR in order to get this issue checked on QA side?

Thanks!
Comment 18 Jeff Muizelaar [:jrmuizel] 2011-08-31 22:07:20 PDT
And again with a nightly from 2011-08-31
Comment 19 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-09-01 04:23:55 PDT
Open a new bug please.
Comment 20 Jeff Muizelaar [:jrmuizel] 2011-09-01 06:51:36 PDT
Done. Bug 683886
Comment 21 Anthony Hughes (:ashughes) [GFX][QA][Mentor] 2011-09-22 15:27:54 PDT
qa- as we are unable to reproduce the issue on an unpatched build. Can someone who is able to reproduce the bug before please verify this fix?

Note You need to log in before you can comment on or make changes to this bug.